/* Filename            : PRBRIEF.P                                       */

{chklevel.i 1}

/*************************************************************************/
/*                                                                       */
/*   INPUT PARAMETERS                                                    */
/*                                                                       */
/*************************************************************************/
DEF INPUT PARAM wz-brfinfo      AS C     NO-UNDO.      /* Info entrylist */
    /*********************************************************************/
    /* 1 entry : number of [TYPE DOC] in MsAccess - required param.     */
    /* 2 entry : type of document                 - optional param.     */
    /*            for special manipulation of data                       */
    /*            1. ORGANIGRAM                                          */
    /*            4. CREATTOT.P                                          */
    /* 3 entry : description n of printjob       - optional param.     */
    /*********************************************************************/
DEF INPUT PARAM wz-recid        AS RECID NO-UNDO.
DEF INPUT PARAM wz-disklabel    AS C     NO-UNDO FORMAT "x(12)".

/*************************************************************************/
/*                                                                       */
/*   LOCAL VARIABLES                                                     */
/*                                                                       */
/*************************************************************************/
DEF VAR i           AS I    NO-UNDO.
DEF VAR wz-brftype  AS I    NO-UNDO.    /* 2 entry of wz-brfinfo        */
DEF VAR wz-descrnr  AS I    NO-UNDO.    /* 3 entry of wz-brfinfo        */
DEF VAR wz-langvlg  AS I    NO-UNDO.    /* Language loopitem             */
DEF VAR wz-langloop AS C    NO-UNDO.    /* Language list                 */
DEF VAR wz-reflijn  AS C    NO-UNDO.    /* Originele afdruklijn          */

DEF VAR wz-maskey   LIKE meta.aesKey                               NO-UNDO.

/* Because CREATTOT uses SHARED VARIABLES instead of a table, we're      */
/* forced to use a RAMDrive-file to pass-through the data to print       */
DEF VAR wz-params   AS C    NO-UNDO FORMAT "x(40)" EXTENT 6.

/*************************************************************************/
/*                                                                       */
/*   INCLUDE FILES                                                       */
/*                                                                       */
/*************************************************************************/
{selvar.i}


{printer.i "SHARED"}        /* Variabelen om printerbestanden te beheren */

/*************************************************************************/
/*                                                                       */
/*   PROGRAM                                                             */
/*                                                                       */
/*************************************************************************/

ASSIGN
wz-doc-type = INT(ENTRY(1,wz-brfinfo))
wz-brftype  = IF NUM-ENTRIES(wz-brfinfo) > 1
              THEN INT(ENTRY(2,wz-brfinfo))
              ELSE 0
wz-descrnr  = IF NUM-ENTRIES(wz-brfinfo) > 2
              THEN INT(ENTRY(3,wz-brfinfo))
              ELSE 0.

IF LOOKUP(STRING(wz-brftype),"1,2,3,4") = 0
THEN wz-brftype = 0.

FIND FIRST setup     NO-LOCK NO-ERROR.
FIND FIRST selection NO-LOCK NO-ERROR.
FIND FIRST session WHERE session.s-id = selection.s-id
                     NO-LOCK NO-ERROR.

IF      wz-brftype = 1
THEN DO:
    FIND FIRST organigram WHERE RECID(organigram) = wz-recid NO-LOCK.
    call CRYPDEC PRPTOT organigram.master-key.
    wz-maskey = result4.
END.
ELSE IF wz-brftype = 4
THEN DO:
    INPUT FROM VALUE(ramdrive + "TOTEXP.INF") NO-ECHO.
    DO i = 1 TO 6:
        SET wz-params[i].
    END.
    INPUT CLOSE.
END.
ELSE DO:
    MESSAGE PROGRAM-NAME(1) "Unknown type :" STRING(wz-brftype).
    PAUSE.
    {return.i}
END.

/* Taalloop bepalen aan de hand van session.lang2 */
wz-langloop =
    IF      session.lang2 = 0   THEN "1"   /* Nederlands  */
    ELSE IF session.lang2 = 1   THEN "2"   /* Frans       */
    ELSE IF session.lang2 = 2   THEN "3"   /* Duits       */
    ELSE IF session.lang2 = 3   THEN "1,2" /* Ned. & Fr.  */
    ELSE IF session.lang2 = 4   THEN "2,3" /* Fr. & Duits */
    ELSE "1". /* Om toch een taal te hebben, maar kan normaal niet */

/* Prefill shared usage-variables */
ASSIGN
wz-setup-id = 0
wz-et-combi = True
wz-et-ids   = "".

AfdrukLoop:
DO wz-langvlg = 1 TO NUM-ENTRIES(wz-langloop) : /* Aantal talen te drukken */

    /* Taalkode voor afdruk van dit exemplaar bepalen */
    ASSIGN
    wz-doc-lang = INT(ENTRY(wz-langvlg,wz-langloop)).

    {call.i &prg="getusage"}
    IF wz-doc-id = -1
    THEN LEAVE AfdrukLoop.

    FIND FIRST layout WHERE layout.doc-id   = wz-doc-id
                        AND layout.sect-nbr = 0
                        AND layout.page-nbr = 0
                        AND layout.line-nbr = 0
                      NO-LOCK NO-ERROR.
    IF AVAILABLE layout
    THEN PagHeader = SUBSTRING(AllSpaces, 1, 75 - LENGTH(layout.contents)) +
                     layout.contents.
    ELSE PagHeader = "".
    {BEGPRT.I "Y" 85 wz-descrnr } /* n outputfile per af te drukken taal */

    ASSIGN
    wz-page-nbr = 0
    wz-line-nbr = 0.
    DO wz-exvlg = 1 TO 2 : /* Aantal exemplaren */

        FOR EACH layout WHERE layout.doc-id   = wz-doc-id
                          AND layout.sect-nbr = 1
                      NO-LOCK:
            wz-lijn = layout.contents.
            {MLBLCONV.I}
            {LBLCONV.I 11}
            LBLCONV12:
            REPEAT WHILE INDEX(wz-lijn,"@F") > 0 :
                ASSIGN
                wz-convto   = ""
                wz-startpos = INDEX(wz-lijn,"@F")
                wz-label    = SUBSTR(wz-lijn,wz-startpos + 2,2)
                wz-resvpos  = INTEGER(SUBSTR(wz-lijn,wz-startpos + 5,2)).

                ASSIGN
                wz-convto =
                    IF wz-brftype = 4 AND
                       LOOKUP(wz-label,"01,02,03,04,05,06") > 0
                    THEN IF LOOKUP(wz-label,"06") > 0
                         THEN /* a password was hidden here by creattot.p ;-) */
                              substring( wz-params[INT(wz-label)],  1, 4) + " " +
                              substring( wz-params[INT(wz-label)],  5, 4) + " " +
                              substring( wz-params[INT(wz-label)],  9, 4) + " " +
                              substring( wz-params[INT(wz-label)], 13, 4)
                         ELSE wz-params[INT(wz-label)]

                    ELSE IF wz-label = "01"
                    THEN IF      wz-brftype = 1
                         THEN organigram.sys-type  +
                              organigram.org-type  +
                              organigram.area[wz-doc-lang] +
                              STRING(organigram.orginator,"999")
                         ELSE "N/A"
                    ELSE IF wz-label = "02"
                    THEN IF      wz-brftype = 1
                         THEN organigram.name
                         ELSE "N/A"
                    ELSE IF wz-label = "03"
                    THEN IF wz-brftype = 1
                         THEN organigram.adres
                         ELSE "N/A"
                    ELSE IF wz-label = "04"
                    THEN IF      wz-brftype = 1
                         THEN organigram.postcode + " " + organigram.lokal
                         ELSE "N/A"
                    ELSE IF wz-label = "05"
                    THEN IF      wz-brftype = 1
                         THEN organigram.tel-nr
                         ELSE "N/A"
                    ELSE IF wz-label = "06"
                    THEN
                         /* 16 bytes passwords must be printed in groups of 4 */
                         IF      wz-brftype = 1
                         THEN
                              substring( wz-maskey,  1, 4) + " " +
                              substring( wz-maskey,  5, 4) + " " +
                              substring( wz-maskey,  9, 4) + " " +
                              substring( wz-maskey, 13, 4)
                         ELSE "N/A"
                    ELSE IF wz-label = "07"
                    THEN IF wz-brftype = 1
                         THEN organigram.area[taalkode]
                         ELSE "N/A"
                    ELSE IF wz-label = "08"
                    THEN IF wz-brftype = 1
                         THEN STRING(organigram.orginator)
                         ELSE "N/A"
                    ELSE IF wz-label = "09"
                    THEN wz-disklabel
                    ELSE "N/A".
                {REPLLBL.I}
            END. /* REPEAT while index - LBLCONV12 */

            /* Special conversion for #looplabels */
            /* Max. 1 looplabel on 1 line         */
            wz-startpos = INDEX(wz-lijn,"#L").
            IF wz-startpos > 0
            THEN DO:
                ASSIGN
                wz-reflijn = wz-lijn /* Ref bewaren waar looplabel staat */
                wz-label   = SUBSTR(wz-reflijn,wz-startpos,3).

                IF wz-label = "#L1" /* Fill-in One or more election names */
                THEN DO:
                    IF wz-brftype = 3
                    THEN wz-convto = "". /* Bij PASWDEST geen election info */
                    ELSE DO:
                        FOR EACH election NO-LOCK
                            BREAK BY election.et-id :
                            
                            IF      wz-brftype = 1 AND
                                     FIRST-OF(election.et-id)
                            THEN wz-convto = election.long-name[wz-doc-lang].
                            ELSE IF wz-brftype = 4 
                            THEN DO:
                                wz-convto = election.long-name[wz-doc-lang].
                                OVERLAY(wz-convto,40) = election.coll_name[wz-doc-lang].
                            END.

                            IF TRIM(wz-convto) <> ""
                            THEN DO:
                                /* Print each line immediately for each conversion */
                                ASSIGN
                                wz-lijn                       = wz-reflijn
                                SUBSTR(wz-lijn,wz-startpos,3) = wz-convto
                                wz-convto                     = "".
                                {LINEPRT.I 1}
                            END.
                        END. /* FOR EACH election */
                    END.
                END. /* #L1 conversion */
            END. /* #L labels */
            ELSE DO:
                {LINEPRT.I 1}
            END.
        END. /* FOR EACH layout */
        PAGE.
        ASSIGN
        wz-page-nbr = wz-page-nbr + 1
        wz-line-nbr = 0.
    END. /* wz-exvlg */
    {ENDPRT.I}
END. /* wz-langvlg */

{return.i}
/* eof */