/* Filename            : VOSTREG.P                                      */
/*
<pvcs>
<workFile>$Workfile:   VOSTREG.P  $</workFile>
<revision>$Revision: 1.12 $</revision>
<workFileTimeStamp>$Modtime:   Feb 25 2004 12:03:44  $</workFileTimeStamp>

<archive>$Archive:   C:/PVCS VM/v6.8.00/DIGIVOTE/Archives/VOTE/TOT/VOSTREG.P-arc  $</archive>
<archiveTimeStamp>$Date: 2009/01/06 13:38:11 $</archiveTimeStamp>
<pvcsUser>$Author: jru $</pvcsUser>
</pvcs>
*/

{chklevel.i 1}

/************************************************************************/
/*                                                                      */
/*        INCLUDE FILES                                                 */
/*                                                                      */
/************************************************************************/
{selvar.i}
{printer.i "SHARED"}       /* Variabelen om printerbestanden te beheren */

/************************************************************************/
/*                                                                      */
/*        LOCAL VARIABLES                                               */
/*                                                                      */
/************************************************************************/
DEF VAR wz-el-type           AS C FORMAT "x(16)"                  NO-UNDO.
DEF VAR wz-afdrloop          AS C                                 NO-UNDO.
DEF VAR wz-afdrvlg           AS I                                 NO-UNDO.
DEF VAR wz-el-mode           AS I                                 NO-UNDO.
DEF VAR wz-index             AS I                                 NO-UNDO.
DEF VAR wz-index-true        AS I                                 NO-UNDO.

DEF VAR wz-total-cards       AS I                                 NO-UNDO.
DEF VAR wz-count-card        AS I EXTENT 16                       NO-UNDO.

DEF VAR wz-totlvls           AS I                                 NO-UNDO.

DEF VAR i                    AS I                                 NO-UNDO.

DEF VAR tmp-taalkode         AS I                                 NO-UNDO.

/************************************************************************/
/*                                                                      */
/*        START PROCEDURE                                               */
/*                                                                      */
/************************************************************************/
FIND FIRST setup     NO-LOCK NO-ERROR.
FIND FIRST selection NO-LOCK NO-ERROR.
FIND FIRST session   WHERE session.s-id = selection.s-id
                     NO-LOCK NO-ERROR.

/* Pre-fill needed query-fields for 'usage'                             */
ASSIGN wz-doc-type       = 80       /* VOORLOPIGE STAAT                 */
       wz-setup-id       = 0        /* All MAMA-disks                   */
       wz-et-combi       = TRUE     /* Only documents for all elections */
       wz-et-ids         = "".

{call.i &prg="elecmode" &param=",INPUT  TRUE,
                                 OUTPUT wz-el-type,
                                 OUTPUT wz-el-mode,
                                 OUTPUT wz-totlvls"}

/* Add number of type electors to doc-type */
wz-doc-type = wz-doc-type + wz-el-mode.

/* Zoek het eerste election type om de titel van het bureau te achterhalen */
FIND FIRST election WHERE election.s-id  = selection.s-id
                      AND election.e-pr  = TRUE
                  NO-LOCK NO-ERROR.

/* Afdrukloop bepalen aan de hand van session.lang2 */
wz-afdrloop =
    IF      session.lang2 = 0   THEN "1"   /* Nederlands  */
    ELSE IF session.lang2 = 1   THEN "2"   /* Frans       */
    ELSE IF session.lang2 = 2   THEN "3"   /* Duits       */
    ELSE IF session.lang2 = 3   THEN "1,2" /* Ned. & Fr.  */
    ELSE IF session.lang2 = 4   THEN "2,3" /* Fr. & Duits */
    ELSE "1". /* Om toch een taal te hebben, maar kan normaal niet */

AfdrukLoop:
DO wz-afdrvlg = 1 TO NUM-ENTRIES(wz-afdrloop) : /* Aantal exemplaren */

    /* Taalkode voor afdruk van dit exemplaar bepalen */
    wz-doc-lang = INT(ENTRY(wz-afdrvlg,wz-afdrloop)).

    {call.i &prg="getusage"}
    IF wz-doc-id = -1
    THEN LEAVE AfdrukLoop.

    FIND FIRST layout WHERE layout.doc-id   = wz-doc-id
                        AND layout.sect-nbr = 0
                        AND layout.page-nbr = 0
                        AND layout.line-nbr = 0
                      NO-LOCK NO-ERROR.
    IF AVAILABLE layout
    THEN PagHeader = SUBSTRING(AllSpaces, 1, 75 - LENGTH(layout.contents)) +
                     layout.contents.
    ELSE PagHeader = "".
    {BEGPRT.I "Y" 80 7}

    ASSIGN wz-page-nbr = 0
           wz-line-nbr = 0.
    FOR EACH layout WHERE layout.doc-id   = wz-doc-id
                      AND layout.sect-nbr = 1
                  NO-LOCK:
        wz-lijn = layout.contents.
        {PAGEBRK.I}
        {LBLCONV.I 11}
        LBLCONV12:
        REPEAT WHILE INDEX(wz-lijn,"@F") > 0 :
            ASSIGN
            wz-convto   = ""
            wz-startpos = INDEX(wz-lijn,"@F")
            wz-label    = SUBSTR(wz-lijn,wz-startpos + 2,2)
            wz-resvpos  = INTEGER(SUBSTR(wz-lijn,wz-startpos + 5,2)).

            ASSIGN
            wz-convto =
                IF      wz-label = "01" /* Titel */
                THEN setup.sys-type +
                     setup.org-type +
                     setup.area     +
                     STRING(setup.orginator,"999")
                ELSE IF wz-label = "50" /* College informatie */
                THEN STRING(IF election.colls
                            THEN ( IF wz-doc-lang = 2
                                   THEN election.head0[wz-doc-lang] + " " +
                                        election.coll_name[wz-doc-lang]
                                   ELSE election.coll_name[wz-doc-lang] + " " +
                                        election.head0[wz-doc-lang]             )
                            ELSE "","x(45)")
                ELSE IF wz-label = "51" /* Heading1 informatie */
                THEN STRING(( IF election.heading1[wz-doc-lang] = ""
                              THEN ""
                              ELSE election.head1[wz-doc-lang] + " : ") +
                            election.heading1[wz-doc-lang],"x(45)")
                ELSE IF wz-label = "52" /* Heading2 informatie */
                THEN STRING(( IF election.heading2[wz-doc-lang] = ""
                              THEN ""
                              ELSE election.head2[wz-doc-lang] + " : ") +
                            election.heading2[wz-doc-lang],"x(45)")
                ELSE IF wz-label = "53" /* Heading3 informatie */
                THEN STRING(election.head3[wz-doc-lang] + " : " +
                            election.heading3[wz-doc-lang],"x(45)")
                ELSE "N/A".
            {REPLLBL.I}
        END. /* REPEAT while index - LBLCONV12 */
        {LINEPRT.I 1}
    END. /* FOR EACH layout */

    FOR EACH urnedest, EACH organigram OF urnedest NO-LOCK:
        call CRYPDEC PRPTOT urnedest.total-cards 1.
        IF crypStat <> 0 THEN LEAVE AfdrukLoop.
        wz-total-cards = INT(result4).
        DO i= 1 TO 16:
            call CRYPDEC PRPTOT urnedest.count-card[i] 1.
            IF crypStat <> 0 THEN LEAVE AfdrukLoop.
            wz-count-card[i] = INT(result4).
        END.
        FOR EACH layout WHERE layout.doc-id   = wz-doc-id
                          AND layout.sect-nbr = 2
                      NO-LOCK:
            wz-lijn = layout.contents.
            {LBLCONV.I 21}
            LBLCONV22:
            REPEAT WHILE INDEX(wz-lijn,"@F") > 0 :
                ASSIGN
                wz-convto   = ""
                wz-startpos = INDEX(wz-lijn,"@F")
                wz-label    = SUBSTR(wz-lijn,wz-startpos + 2,2)
                wz-resvpos  = INTEGER(SUBSTR(wz-lijn,wz-startpos + 5,2)).

                ASSIGN
                wz-convto   =
                    IF      wz-label = "01"
                    THEN organigram.sys-type  +
                         organigram.org-type  +
                         organigram.area[taalkode] +
                         STRING(organigram.orginator,"999")
                    ELSE "N/A".
                {REPLLBL.I}
            END. /* REPEAT while index - LBLCONV22 */
            LBLCONV23:
            REPEAT WHILE INDEX(wz-lijn,"@U") > 0 :
                ASSIGN
                wz-convto   = ""
                wz-startpos = INDEX(wz-lijn,"@U")
                wz-label    = SUBSTR(wz-lijn,wz-startpos + 2,2)
                wz-resvpos  = 5.

                ASSIGN
                wz-convto   =
                    IF      wz-label = "01"
                    THEN urnedest.time-rcv
                    ELSE "N/A".
                {REPLLBL.I 4}
            END. /* REPEAT while index - LBLCONV23 */
            LBLCONV24:
            REPEAT WHILE INDEX(wz-lijn,"@T") > 0 :
                ASSIGN
                wz-convto   = ""
                wz-startpos = INDEX(wz-lijn,"@T")
                wz-label    = SUBSTR(wz-lijn,wz-startpos + 2,2)
                wz-resvpos  = 6.

                ASSIGN
                wz-convto   =
                    IF      wz-label = "80" /* Geregistreerde kaarten */
/*@source sec=1*/
                    THEN STRING(wz-total-cards, ">>>>>9")
                    ELSE IF LOOKUP(wz-label,
                         "81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96") > 0
                    THEN STRING(wz-count-card[INT(wz-label) - 80], ">>>>>9")
/*@source sec=0*/
                    ELSE "N/A".
                {REPLLBL.I 4}
            END. /* REPEAT while index - LBLCONV24 */

            ASSIGN wz-line-nbr = layout.line-nbr.
            {LINEPRT.I 0}
        END. /* FOR EACH layout */
    END.

    FOR EACH layout WHERE layout.doc-id   = wz-doc-id
                      AND layout.sect-nbr = 3
                  NO-LOCK:
        wz-lijn = layout.contents.
        {PAGEBRK.I}
        {LBLCONV.I 31}
        LBLCONV32:
        REPEAT WHILE INDEX(wz-lijn,"@F") > 0 :
            ASSIGN
            wz-convto   = ""
            wz-startpos = INDEX(wz-lijn,"@F")
            wz-label    = SUBSTR(wz-lijn,wz-startpos + 2,2)
            wz-resvpos  = INTEGER(SUBSTR(wz-lijn,wz-startpos + 5,2)).

            IF LOOKUP(wz-label,
                      "01,02,03,04,05,06,07,08,09,10,11,12,13,14,15,16") > 0
            THEN DO:
                wz-index-true = 0.
                DO wz-index = 1 TO 16:
                    IF SUBSTRING( wz-el-type, wz-index, 1) = "T"
                    THEN wz-index-true = wz-index-true + 1.

                    IF wz-index-true = INT(wz-label)
                    THEN DO:
                        ASSIGN
                        wz-el-mode = EXP( 2, wz-index - 1)
                        wz-index   = 16.
                    END.
                END.
                ASSIGN
                tmp-taalkode = taalkode
                taalkode     = wz-doc-lang.
                {call.i &prg="mesfil" &param=",'vostreg,type' + STRING(wz-el-mode,'99'),0,
                                      OUTPUT wz-convto"}
                taalkode     = tmp-taalkode.
            END.
            ELSE wz-convto = "N/A".
            {REPLLBL.I}
        END. /* REPEAT while index - LBLCONV32 */
        {LINEPRT.I 1}
    END. /* FOR EACH layout */

    {ENDPRT.I}

END. /* wz-afdrloop : Afdrukloop # talen en # exemplaren */

{return.i}
/* eof */